
# q-expansion of newform 756.2.a.f, downloaded from the LMFDB on 25 April 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 756
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[0], [0], [3], [1], [3], [2], [-6], [5], [-9], [6], [-1], [11], [3], [-4], [-12], [0], [0], [8], [-10], [3], [8], [-4], [6], [3], [8], [-18], [-1], [12], [5], [-6], [-22], [0], [-18], [-4], [-18], [-10], [-22], [2], [-18], [21], [-12], [2], [21], [-10], [6], [11], [-22], [17], [18], [20], [-18], [-12], [-28], [0], [15], [3], [15], [20], [23], [-24], [20], [-18], [-7], [-6], [26], [12], [-16], [-13], [-9], [26], [-3], [0], [-13], [17], [-16], [18], [12], [-22], [6], [-4], [30], [35], [-3], [-10], [8], [-39], [30], [-31], [9], [26], [24], [0], [-40], [15], [32], [42], [-30], [-15], [5], [11], [8], [-30], [-18], [-42], [-22], [14], [-18], [-15], [33], [-34], [-4], [-25], [-12], [-25], [20], [42], [5], [-24], [48], [27], [2], [2], [33], [45], [-40], [30], [17], [24], [8], [-28], [-22], [-9], [-4], [-34], [-6], [-10], [45], [-4], [-3], [-6], [11], [0], [14], [33], [-4], [18], [32], [39], [-31], [12], [-22], [21], [32], [30], [14], [-24], [20], [6], [-52], [15], [-15], [-6], [-10], [30], [48], [-36], [-22], [-10]]
